   Generated by Sphinx 5.3.0.

The GNU D Compiler
******************

     The GNU D Compiler 13.0.1 (experimental 20220101), Nov 08, 2022

     David Friedman, Iain Buclaw

     Copyright © 2006-2022 Free Software Foundation, Inc.

1 Copyright
***********

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.3 or
any later version published by the Free Software Foundation; with no
Invariant Sections, no Front-Cover Texts, and no Back-Cover Texts.  A
copy of the license is in the GNU Free Documentation License.

2 Invoking gdc
**************

2.1 Description
===============

The ‘gdc’ command is the GNU compiler for the D language and supports
many of the same options as ‘gcc’.  See Option Summary(1).  This manual
only documents the options specific to ‘gdc’.

   ---------- Footnotes ----------

   (1)
https://splichal.eu/scripts/sphinx/gcc/_build/html/gcc-command-options/option-summary.html#option-summary

2.2 Options
===========

2.2.1 Input and Output files
----------------------------

For any given input file, the file name suffix determines what kind of
compilation is done.  The following kinds of input file names are
supported:

‘FILE.d’

     D source files.

‘FILE.dd’

     Ddoc source files.

‘FILE.di’

     D interface files.

You can specify more than one input file on the ‘gdc’ command line, each
being compiled separately in the compilation process.  If you specify a
‘-o file’ option, all the input files are compiled together, producing a
single output file, named ‘FILE’.  This is allowed even when using ‘-S’
or ‘-c’.

A D interface file contains only what an import of the module needs,
rather than the whole implementation of that module.  They can be
created by ‘gdc’ from a D source file by using the ‘-H’ option.  When
the compiler resolves an import declaration, it searches for matching
‘.di’ files first, then for ‘.d’.

A Ddoc source file contains code in the D macro processor language.  It
is primarily designed for use in producing user documentation from
embedded comments, with a slight affinity towards HTML generation.  If a
‘.d’ source file starts with the string ‘Ddoc’ then it is treated as
general purpose documentation, not as a D source file.

2.2.2 Runtime Options
---------------------

These options affect the runtime behavior of programs compiled with
‘gdc’.

 -- Option: -fall-instantiations

     Generate code for all template instantiations.  The default
     template emission strategy is to not generate code for declarations
     that were either instantiated speculatively, such as from
     ‘__traits(compiles, ...)’, or that come from an imported module not
     being compiled.

 -- Option: -fno-assert

     Turn off code generation for ‘assert’ contracts.

 -- Option: -fno-bounds-check

     Turns off array bounds checking for all functions, which can
     improve performance for code that uses arrays extensively.  Note
     that this can result in unpredictable behavior if the code in
     question actually does violate array bounds constraints.  It is
     safe to use this option if you are sure that your code never throws
     a ‘RangeError’.

 -- Option: -fbounds-check=value

     An alternative to -fbounds-check that allows more control as to
     where bounds checking is turned on or off.  The following values
     are supported:

     ‘on’

          Turns on array bounds checking for all functions.

     ‘safeonly’

          Turns on array bounds checking only for ‘@safe’ functions.

     ‘off’

          Turns off array bounds checking completely.

 -- Option: -fno-builtin

     Don’t recognize built-in functions unless they begin with the
     prefix ‘__builtin_’.  By default, the compiler will recognize when
     a function in the ‘core.stdc’ package is a built-in function.

 -- Option: -fcheckaction

     This option controls what code is generated on an assertion, bounds
     check, or final switch failure.  The following values are
     supported:

     ‘context’

          Throw an ‘AssertError’ with extra context information.

     ‘halt’

          Halt the program execution.

     ‘throw’

          Throw an ‘AssertError’ (the default).

 -- Option: -fdebug=value

     Turn on compilation of conditional ‘debug’ code into the program.
     The -fdebug option itself sets the debug level to ‘1’, while
     -fdebug= enables ‘debug’ code that are identified by any of the
     following values:

     ‘level’

          Sets the debug level to ‘LEVEL’, any ‘debug’ code <= ‘LEVEL’
          is compiled into the program.

     ‘ident’

          Turns on compilation of any ‘debug’ code identified by
          ‘IDENT’.

 -- Option: -fno-druntime

     Implements ‘https://dlang.org/spec/betterc.html’.  Assumes that
     compilation targets an environment without a D runtime library.

     This is equivalent to compiling with the following options:

          gdc -nophoboslib -fno-exceptions -fno-moduleinfo -fno-rtti

 -- Option: -fextern-std=standard

     Sets the C++ name mangling compatibility to the version identified
     by ‘STANDARD’.  The following values are supported:

     ‘c++98’, ‘c++03’

          Sets ‘__traits(getTargetInfo, "cppStd")’ to ‘199711’.

     ‘c++11’

          Sets ‘__traits(getTargetInfo, "cppStd")’ to ‘201103’.

     ‘c++14’

          Sets ‘__traits(getTargetInfo, "cppStd")’ to ‘201402’.

     ‘c++17’

          Sets ‘__traits(getTargetInfo, "cppStd")’ to ‘201703’.  This is
          the default.

     ‘c++20’

          Sets ‘__traits(getTargetInfo, "cppStd")’ to ‘202002’.

 -- Option: -fno-invariants

     Turns off code generation for class ‘invariant’ contracts.

 -- Option: -fmain

     Generates a default ‘main()’ function when compiling.  This is
     useful when unittesting a library, as it enables running the
     unittests in a library without having to manually define an
     entry-point function.  This option does nothing when ‘main’ is
     already defined in user code.

 -- Option: -fno-moduleinfo

     Turns off generation of the ‘ModuleInfo’ and related functions that
     would become unreferenced without it, which may allow linking to
     programs not written in D. Functions that are not be generated
     include module constructors and destructors (‘static this’ and
     ‘static ~this’), ‘unittest’ code, and ‘DSO’ registry functions for
     dynamically linked code.

 -- Option: -fonly=filename

     Tells the compiler to parse and run semantic analysis on all
     modules on the command line, but only generate code for the module
     specified by ‘FILENAME’.

 -- Option: -fno-postconditions

     Turns off code generation for postcondition ‘out’ contracts.

 -- Option: -fno-preconditions

     Turns off code generation for precondition ‘in’ contracts.

 -- Option: -fpreview=id

     Turns on an upcoming D language change identified by ‘ID’.  The
     following values are supported:

     ‘all’

          Turns on all upcoming D language features.

     ‘dip1000’

          Implements
          ‘https://github.com/dlang/DIPs/blob/master/DIPs/other/DIP1000.md’
          (Scoped pointers).

     ‘dip1008’

          Implements
          ‘https://github.com/dlang/DIPs/blob/master/DIPs/other/DIP1008.md’
          (Allow exceptions in ‘@nogc’ code).

     ‘dip1021’

          Implements
          ‘https://github.com/dlang/DIPs/blob/master/DIPs/accepted/DIP1021.md’
          (Mutable function arguments).

     ‘dip25’

          Implements
          ‘https://github.com/dlang/DIPs/blob/master/DIPs/archive/DIP25.md’
          (Sealed references).

     ‘dtorfields’

          Turns on generation for destructing fields of partially
          constructed objects.

     ‘fieldwise’

          Turns on generation of struct equality to use field-wise
          comparisons.

     ‘fixaliasthis’

          Implements new lookup rules that check the current scope for
          ‘alias this’ before searching in upper scopes.

     ‘fiximmutableconv’

          Disallows unsound immutable conversions that were formerly
          incorrectly permitted.

     ‘in’

          Implements ‘in’ parameters to mean ‘scope const [ref]’ and
          accepts rvalues.

     ‘inclusiveincontracts’

          Implements ‘in’ contracts of overridden methods to be a
          superset of parent contract.

     ‘intpromote’

          Implements C-style integral promotion for unary ‘+’, ‘-’ and
          ‘~’ expressions.

     ‘nosharedaccess’

          Turns off and disallows all access to shared memory objects.

     ‘rvaluerefparam’

          Implements rvalue arguments to ‘ref’ parameters.

     ‘systemvariables’

          Disables access to variables marked ‘@system’ from ‘@safe’
          code.

 -- Option: -frelease

     Turns on compiling in release mode, which means not emitting
     runtime checks for contracts and asserts.  Array bounds checking is
     not done for ‘@system’ and ‘@trusted’ functions, and assertion
     failures are undefined behavior.

     This is equivalent to compiling with the following options:

          gdc -fno-assert -fbounds-check=safe -fno-invariants \
              -fno-postconditions -fno-preconditions -fno-switch-errors

 -- Option: -frevert=

     Turns off a D language feature identified by ‘ID’.  The following
     values are supported:

     ‘all’

          Turns off all revertable D language features.

     ‘dip25’

          Reverts
          ‘https://github.com/dlang/DIPs/blob/master/DIPs/archive/DIP25.md’
          (Sealed references).

     ‘dtorfields’

          Turns off generation for destructing fields of partially
          constructed objects.

     ‘markdown’

          Turns off Markdown replacements in Ddoc comments.

 -- Option: -fno-rtti

     Turns off generation of run-time type information for all user
     defined types.  Any code that uses features of the language that
     require access to this information will result in an error.

 -- Option: -fno-switch-errors

     This option controls what code is generated when no case is matched
     in a ‘final switch’ statement.  The default run time behavior is to
     throw a ‘SwitchError’.  Turning off ‘-fswitch-errors’ means that
     instead the execution of the program is immediately halted.

 -- Option: -funittest

     Turns on compilation of ‘unittest’ code, and turns on the
     ‘version(unittest)’ identifier.  This implies ‘-fassert’.

 -- Option: -fversion=value

     Turns on compilation of conditional ‘version’ code into the program
     identified by any of the following values:

     ‘level’

          Sets the version level to ‘LEVEL’, any ‘version’ code >=
          ‘LEVEL’ is compiled into the program.

     ‘ident’

          Turns on compilation of ‘version’ code identified by ‘IDENT’.

 -- Option: -fno-weak-templates

     Turns off emission of declarations that can be defined in multiple
     objects as weak symbols.  The default is to emit all public symbols
     as weak, unless the target lacks support for weak symbols.
     Disabling this option means that common symbols are instead put in
     COMDAT or become private.

2.2.3 Options for Directory Search
----------------------------------

These options specify directories to search for files, libraries, and
other parts of the compiler:

 -- Option: -Idir

     Specify a directory to use when searching for imported modules at
     compile time.  Multiple -I(1) options can be used, and the paths
     are searched in the same order.

 -- Option: -Jdir

     Specify a directory to use when searching for files in string
     imports at compile time.  This switch is required in order to use
     ‘import(file)’ expressions.  Multiple ‘-J’ options can be used, and
     the paths are searched in the same order.

 -- Option: -Ldir

     When linking, specify a library search directory, as with ‘gcc’.

 -- Option: -Bdir

     This option specifies where to find the executables, libraries,
     source files, and data files of the compiler itself, as with ‘gcc’.

 -- Option: -fmodule-file=module=spec

     This option manipulates file paths of imported modules, such that
     if an imported module matches all or the leftmost part of ‘MODULE’,
     the file path in ‘SPEC’ is used as the location to search for D
     sources.  This is used when the source file path and names are not
     the same as the package and module hierarchy.  Consider the
     following examples:

          gdc test.d -fmodule-file=A.B=foo.d -fmodule-file=C=bar

     This will tell the compiler to search in all import paths for the
     source file ‘FOO.D’ when importing ‘A.B’, and the directory ‘BAR/’
     when importing ‘C’, as annotated in the following D code:

          module test;
          import A.B;     // Matches A.B, searches for foo.d
          import C.D.E;   // Matches C, searches for bar/D/E.d
          import A.B.C;   // No match, searches for A/B/C.d

 -- Option: -imultilib dir

     Use ‘DIR’ as a subdirectory of the gcc directory containing
     target-specific D sources and interfaces.

 -- Option: -iprefix prefix

     Specify ‘PREFIX’ as the prefix for the gcc directory containing
     target-specific D sources and interfaces.  If the ‘PREFIX’
     represents a directory, you should include the final ‘'/'’.

 -- Option: -nostdinc

     Do not search the standard system directories for D source and
     interface files.  Only the directories that have been specified
     with -I(2) options (and the directory of the current file, if
     appropriate) are searched.

   ---------- Footnotes ----------

   (1)
https://splichal.eu/scripts/sphinx/gcc/_build/html/gcc-command-options/options-for-directory-search.html#cmdoption-I

   (2)
https://splichal.eu/scripts/sphinx/gcc/_build/html/gcc-command-options/options-for-directory-search.html#cmdoption-I

2.2.4 Code Generation
---------------------

In addition to the many ‘gcc’ options controlling code generation, ‘gdc’
has several options specific to itself.

 -- Option: -H

     Generates D interface files for all modules being compiled.  The
     compiler determines the output file based on the name of the input
     file, removes any directory components and suffix, and applies the
     ‘.di’ suffix.

 -- Option: -Hd dir

     Same as -H, but writes interface files to directory ‘DIR’.  This
     option can be used with -Hf file to independently set the output
     file and directory path.

 -- Option: -Hf file

     Same as -H but writes interface files to ‘FILE’.  This option can
     be used with -Hd dir to independently set the output file and
     directory path.

 -- Option: -M

     Output the module dependencies of all source files being compiled
     in a format suitable for ‘make’.  The compiler outputs one ‘make’
     rule containing the object file name for that source file, a colon,
     and the names of all imported files.

 -- Option: -MM

     Like -M but does not mention imported modules from the D standard
     library package directories.

 -- Option: -MF file

     When used with -M or -MM, specifies a ‘FILE’ to write the
     dependencies to.  When used with the driver options -MD or -MMD,
     -MF overrides the default dependency output file.

 -- Option: -MG

     This option is for compatibility with ‘gcc’, and is ignored by the
     compiler.

 -- Option: -MP

     Outputs a phony target for each dependency other than the modules
     being compiled, causing each to depend on nothing.

 -- Option: -MT target

     Change the ‘TARGET’ of the rule emitted by dependency generation to
     be exactly the string you specify.  If you want multiple targets,
     you can specify them as a single argument to -MT, or use multiple
     -MT options.

 -- Option: -MQ target

     Same as -MT, but it quotes any characters which are special to
     ‘make’.

 -- Option: -MD

     This option is equivalent to -M -MF file.  The driver determines
     ‘FILE’ by removing any directory components and suffix from the
     input file, and then adding a ‘.deps’ suffix.

 -- Option: -MMD

     Like -MD but does not mention imported modules from the D standard
     library package directories.

 -- Option: -X

     Output information describing the contents of all source files
     being compiled in JSON format to a file.  The driver determines
     ‘FILE’ by removing any directory components and suffix from the
     input file, and then adding a ‘.json’ suffix.

 -- Option: -Xf file

     Same as -X, but writes all JSON contents to the specified ‘FILE’.

 -- Option: -fdoc

     Generates ‘Ddoc’ documentation and writes it to a file.  The
     compiler determines ‘FILE’ by removing any directory components and
     suffix from the input file, and then adding a ‘.html’ suffix.

 -- Option: -fdoc-dir=dir

     Same as -fdoc, but writes documentation to directory ‘DIR’.  This
     option can be used with -fdoc-file=file to independently set the
     output file and directory path.

 -- Option: -fdoc-file=file

     Same as -fdoc, but writes documentation to ‘FILE’.  This option can
     be used with -fdoc-dir=dir to independently set the output file and
     directory path.

 -- Option: -fdoc-inc=file

     Specify ‘FILE’ as a ‘DDOC’ macro file to be read.  Multiple
     -fdoc-inc options can be used, and files are read and processed in
     the same order.

 -- Option: -fdump-c++-spec=`file'

     For D source files, generate corresponding C++ declarations in
     ‘FILE’.

 -- Option: -fdump-c++-spec-verbose

     In conjunction with -fdump-c++-spec= above, add comments for
     ignored declarations in the generated C++ header.

 -- Option: -fsave-mixins=`file'

     Generates code expanded from D ‘mixin’ statements and writes the
     processed sources to ‘FILE’.  This is useful to debug errors in
     compilation and provides source for debuggers to show when
     requested.

2.2.5 Warnings
--------------

Warnings are diagnostic messages that report constructions that are not
inherently erroneous but that are risky or suggest there is likely to be
a bug in the program.  Unless -Werror is specified, they do not prevent
compilation of the program.

 -- Option: -Wall

     Turns on all warnings messages.  Warnings are not a defined part of
     the D language, and all constructs for which this may generate a
     warning message are valid code.

 -- Option: -Walloca

     This option warns on all uses of “alloca” in the source.

 -- Option: -Walloca-larger-than=n

     Warn on unbounded uses of alloca, and on bounded uses of alloca
     whose bound can be larger than ‘N’ bytes.
     -Wno-alloca-larger-than(1) disables -Walloca-larger-than warning
     and is equivalent to -Walloca-larger-than=SIZE_MAX or larger.

 -- Option: -Wcast-result

     Warn about casts that will produce a null or zero result.
     Currently this is only done for casting between an imaginary and
     non-imaginary data type, or casting between a D and C++ class.

 -- Option: -Wno-deprecated

     Do not warn about usage of deprecated features and symbols with
     ‘deprecated’ attributes.

 -- Option: -Werror

     Turns all warnings into errors.

 -- Option: -Wspeculative

     List all error messages from speculative compiles, such as
     ‘__traits(compiles, ...)’.  This option does not report messages as
     warnings, and these messages therefore never become errors when the
     -Werror option is also used.

 -- Option: -Wtemplates

     Warn when a template instantiation is encountered.  Some coding
     rules disallow templates, and this may be used to enforce that
     rule.

 -- Option: -Wunknown-pragmas

     Warn when a ‘pragma()’ is encountered that is not understood by
     ‘gdc’.  This differs from -fignore-unknown-pragmas where a pragma
     that is part of the D language, but not implemented by the
     compiler, won’t get reported.

 -- Option: -Wno-varargs

     Do not warn upon questionable usage of the macros used to handle
     variable arguments like ‘va_start’.

 -- Option: -fignore-unknown-pragmas

     Turns off errors for unsupported pragmas.

 -- Option: -fmax-errors=n

     Limits the maximum number of error messages to ‘N’, at which point
     ‘gdc’ bails out rather than attempting to continue processing the
     source code.  If ‘N’ is 0 (the default), there is no limit on the
     number of error messages produced.

 -- Option: -fsyntax-only

     Check the code for syntax errors, but do not actually compile it.
     This can be used in conjunction with -fdoc or -H to generate files
     for each module present on the command-line, but no other output
     file.

 -- Option: -ftransition=id

     Report additional information about D language changes identified
     by ‘ID’.  The following values are supported:

     ‘all’

          List information on all D language transitions.

     ‘complex’

          List all usages of complex or imaginary types.

     ‘field’

          List all non-mutable fields which occupy an object instance.

     ‘in’

          List all usages of ‘in’ on parameter.

     ‘nogc’

          List all hidden GC allocations.

     ‘templates’

          List statistics on template instantiations.

     ‘tls’

          List all variables going into thread local storage.

     ‘vmarkdown’

          List instances of Markdown replacements in Ddoc.

   ---------- Footnotes ----------

   (1)
https://splichal.eu/scripts/sphinx/gcc/_build/html/gcc-command-options/options-to-request-or-suppress-warnings.html#cmdoption-Wno-alloca-larger-than

2.2.6 Options for Linking
-------------------------

These options come into play when the compiler links object files into
an executable output file.  They are meaningless if the compiler is not
doing a link step.

 -- Option: -defaultlib=libname

     Specify the library to use instead of libphobos when linking.
     Options specifying the linkage of libphobos, such as
     -static-libphobos or -shared-libphobos, are ignored.

 -- Option: -debuglib=libname

     Specify the debug library to use instead of libphobos when linking.
     This option has no effect unless the -g(1) option was also given on
     the command line.  Options specifying the linkage of libphobos,
     such as -static-libphobos or -shared-libphobos, are ignored.

 -- Option: -nophoboslib

     Do not use the Phobos or D runtime library when linking.  Options
     specifying the linkage of libphobos, such as -static-libphobos or
     -shared-libphobos, are ignored.  The standard system libraries are
     used normally, unless -nostdlib(2) or -nodefaultlibs(3) is used.

 -- Option: -shared-libphobos

     On systems that provide ‘libgphobos’ and ‘libgdruntime’ as a shared
     and a static library, this option forces the use of the shared
     version.  If no shared version was built when the compiler was
     configured, this option has no effect.

 -- Option: -static-libphobos

     On systems that provide ‘libgphobos’ and ‘libgdruntime’ as a shared
     and a static library, this option forces the use of the static
     version.  If no static version was built when the compiler was
     configured, this option has no effect.

   ---------- Footnotes ----------

   (1)
https://splichal.eu/scripts/sphinx/gccgo/_build/html/invoking-gccgo.html#cmdoption-g

   (2)
https://splichal.eu/scripts/sphinx/gcc/_build/html/gcc-command-options/options-for-linking.html#cmdoption-nostdlib

   (3)
https://splichal.eu/scripts/sphinx/gcc/_build/html/gcc-command-options/options-for-linking.html#cmdoption-nodefaultlibs

2.2.7 Developer Options
-----------------------

This section describes command-line options that are primarily of
interest to developers or language tooling.

 -- Option: -fdump-d-original

     Output the internal front-end AST after the ‘semantic3’ stage.
     This option is only useful for debugging the GNU D compiler itself.

 -- Option: -v

     Dump information about the compiler language processing stages as
     the source program is being compiled.  This includes listing all
     modules that are processed through the ‘parse’, ‘semantic’,
     ‘semantic2’, and ‘semantic3’ stages; all ‘import’ modules and their
     file paths; and all ‘function’ bodies that are being compiled.

3 GNU GENERAL PUBLIC LICENSE
****************************

Version 3, 29 June 2007

Copyright (C) 2007 Free Software Foundation, Inc.  ‘https://fsf.org/’

Everyone is permitted to copy and distribute verbatim copies of this
license document, but changing it is not allowed.

3.1 Preamble
============

The GNU General Public License is a free, copyleft license for software
and other kinds of works.

The licenses for most software and other practical works are designed to
take away your freedom to share and change the works.  By contrast, the
GNU General Public License is intended to guarantee your freedom to
share and change all versions of a program–to make sure it remains free
software for all its users.  We, the Free Software Foundation, use the
GNU General Public License for most of our software; it applies also to
any other work released this way by its authors.  You can apply it to
your programs, too.

When we speak of free software, we are referring to freedom, not price.
Our General Public Licenses are designed to make sure that you have the
freedom to distribute copies of free software (and charge for them if
you wish), that you receive source code or can get it if you want it,
that you can change the software or use pieces of it in new free
programs, and that you know you can do these things.

To protect your rights, we need to prevent others from denying you these
rights or asking you to surrender the rights.  Therefore, you have
certain responsibilities if you distribute copies of the software, or if
you modify it: responsibilities to respect the freedom of others.

For example, if you distribute copies of such a program, whether gratis
or for a fee, you must pass on to the recipients the same freedoms that
you received.  You must make sure that they, too, receive or can get the
source code.  And you must show them these terms so they know their
rights.

Developers that use the GNU GPL protect your rights with two steps: (1)
assert copyright on the software, and (2) offer you this License giving
you legal permission to copy, distribute and/or modify it.

For the developers’ and authors’ protection, the GPL clearly explains
that there is no warranty for this free software.  For both users’ and
authors’ sake, the GPL requires that modified versions be marked as
changed, so that their problems will not be attributed erroneously to
authors of previous versions.

Some devices are designed to deny users access to install or run
modified versions of the software inside them, although the manufacturer
can do so.  This is fundamentally incompatible with the aim of
protecting users’ freedom to change the software.  The systematic
pattern of such abuse occurs in the area of products for individuals to
use, which is precisely where it is most unacceptable.  Therefore, we
have designed this version of the GPL to prohibit the practice for those
products.  If such problems arise substantially in other domains, we
stand ready to extend this provision to those domains in future versions
of the GPL, as needed to protect the freedom of users.

Finally, every program is threatened constantly by software patents.
States should not allow patents to restrict development and use of
software on general-purpose computers, but in those that do, we wish to
avoid the special danger that patents applied to a free program could
make it effectively proprietary.  To prevent this, the GPL assures that
patents cannot be used to render the program non-free.

The precise terms and conditions for copying, distribution and
modification follow.

3.2 TERMS AND CONDITIONS
========================

3.2.1 0. Definitions.
---------------------

“This License” refers to version 3 of the GNU General Public License.

“Copyright” also means copyright-like laws that apply to other kinds of
works, such as semiconductor masks.

“The Program” refers to any copyrightable work licensed under this
License.  Each licensee is addressed as “you”.  “Licensees” and
“recipients” may be individuals or organizations.

To “modify” a work means to copy from or adapt all or part of the work
in a fashion requiring copyright permission, other than the making of an
exact copy.  The resulting work is called a “modified version” of the
earlier work or a work “based on” the earlier work.

A “covered work” means either the unmodified Program or a work based on
the Program.

To “propagate” a work means to do anything with it that, without
permission, would make you directly or secondarily liable for
infringement under applicable copyright law, except executing it on a
computer or modifying a private copy.  Propagation includes copying,
distribution (with or without modification), making available to the
public, and in some countries other activities as well.

To “convey” a work means any kind of propagation that enables other
parties to make or receive copies.  Mere interaction with a user through
a computer network, with no transfer of a copy, is not conveying.

An interactive user interface displays “Appropriate Legal Notices” to
the extent that it includes a convenient and prominently visible feature
that (1) displays an appropriate copyright notice, and (2) tells the
user that there is no warranty for the work (except to the extent that
warranties are provided), that licensees may convey the work under this
License, and how to view a copy of this License.  If the interface
presents a list of user commands or options, such as a menu, a prominent
item in the list meets this criterion.

3.2.2 1. Source Code.
---------------------

The “source code” for a work means the preferred form of the work for
making modifications to it.  “Object code” means any non-source form of
a work.

A “Standard Interface” means an interface that either is an official
standard defined by a recognized standards body, or, in the case of
interfaces specified for a particular programming language, one that is
widely used among developers working in that language.

The “System Libraries” of an executable work include anything, other
than the work as a whole, that (a) is included in the normal form of
packaging a Major Component, but which is not part of that Major
Component, and (b) serves only to enable use of the work with that Major
Component, or to implement a Standard Interface for which an
implementation is available to the public in source code form.  A “Major
Component”, in this context, means a major essential component (kernel,
window system, and so on) of the specific operating system (if any) on
which the executable work runs, or a compiler used to produce the work,
or an object code interpreter used to run it.

The “Corresponding Source” for a work in object code form means all the
source code needed to generate, install, and (for an executable work)
run the object code and to modify the work, including scripts to control
those activities.  However, it does not include the work’s System
Libraries, or general-purpose tools or generally available free programs
which are used unmodified in performing those activities but which are
not part of the work.  For example, Corresponding Source includes
interface definition files associated with source files for the work,
and the source code for shared libraries and dynamically linked
subprograms that the work is specifically designed to require, such as
by intimate data communication or control flow between those subprograms
and other parts of the work.

The Corresponding Source need not include anything that users can
regenerate automatically from other parts of the Corresponding Source.

The Corresponding Source for a work in source code form is that same
work.

3.2.3 2. Basic Permissions.
---------------------------

All rights granted under this License are granted for the term of
copyright on the Program, and are irrevocable provided the stated
conditions are met.  This License explicitly affirms your unlimited
permission to run the unmodified Program.  The output from running a
covered work is covered by this License only if the output, given its
content, constitutes a covered work.  This License acknowledges your
rights of fair use or other equivalent, as provided by copyright law.

You may make, run and propagate covered works that you do not convey,
without conditions so long as your license otherwise remains in force.
You may convey covered works to others for the sole purpose of having
them make modifications exclusively for you, or provide you with
facilities for running those works, provided that you comply with the
terms of this License in conveying all material for which you do not
control copyright.  Those thus making or running the covered works for
you must do so exclusively on your behalf, under your direction and
control, on terms that prohibit them from making any copies of your
copyrighted material outside their relationship with you.

Conveying under any other circumstances is permitted solely under the
conditions stated below.  Sublicensing is not allowed; section 10 makes
it unnecessary.

3.2.4 3. Protecting Users’ Legal Rights From Anti-Circumvention Law.
--------------------------------------------------------------------

No covered work shall be deemed part of an effective technological
measure under any applicable law fulfilling obligations under article 11
of the WIPO copyright treaty adopted on 20 December 1996, or similar
laws prohibiting or restricting circumvention of such measures.

When you convey a covered work, you waive any legal power to forbid
circumvention of technological measures to the extent such circumvention
is effected by exercising rights under this License with respect to the
covered work, and you disclaim any intention to limit operation or
modification of the work as a means of enforcing, against the work’s
users, your or third parties’ legal rights to forbid circumvention of
technological measures.

3.2.5 4. Conveying Verbatim Copies.
-----------------------------------

You may convey verbatim copies of the Program’s source code as you
receive it, in any medium, provided that you conspicuously and
appropriately publish on each copy an appropriate copyright notice; keep
intact all notices stating that this License and any non-permissive
terms added in accord with section 7 apply to the code; keep intact all
notices of the absence of any warranty; and give all recipients a copy
of this License along with the Program.

You may charge any price or no price for each copy that you convey, and
you may offer support or warranty protection for a fee.

3.2.6 5. Conveying Modified Source Versions.
--------------------------------------------

You may convey a work based on the Program, or the modifications to
produce it from the Program, in the form of source code under the terms
of section 4, provided that you also meet all of these conditions:

  a. The work must carry prominent notices stating that you modified it,
     and giving a relevant date.

  b. The work must carry prominent notices stating that it is released
     under this License and any conditions added under section 7.  This
     requirement modifies the requirement in section 4 to “keep intact
     all notices”.

  c. You must license the entire work, as a whole, under this License to
     anyone who comes into possession of a copy.  This License will
     therefore apply, along with any applicable section 7 additional
     terms, to the whole of the work, and all its parts, regardless of
     how they are packaged.  This License gives no permission to license
     the work in any other way, but it does not invalidate such
     permission if you have separately received it.

  d. If the work has interactive user interfaces, each must display
     Appropriate Legal Notices; however, if the Program has interactive
     interfaces that do not display Appropriate Legal Notices, your work
     need not make them do so.

A compilation of a covered work with other separate and independent
works, which are not by their nature extensions of the covered work, and
which are not combined with it such as to form a larger program, in or
on a volume of a storage or distribution medium, is called an
“aggregate” if the compilation and its resulting copyright are not used
to limit the access or legal rights of the compilation’s users beyond
what the individual works permit.  Inclusion of a covered work in an
aggregate does not cause this License to apply to the other parts of the
aggregate.

3.2.7 6. Conveying Non-Source Forms.
------------------------------------

You may convey a covered work in object code form under the terms of
sections 4 and 5, provided that you also convey the machine-readable
Corresponding Source under the terms of this License, in one of these
ways:

  a. Convey the object code in, or embodied in, a physical product
     (including a physical distribution medium), accompanied by the
     Corresponding Source fixed on a durable physical medium customarily
     used for software interchange.

  b. Convey the object code in, or embodied in, a physical product
     (including a physical distribution medium), accompanied by a
     written offer, valid for at least three years and valid for as long
     as you offer spare parts or customer support for that product
     model, to give anyone who possesses the object code either (1) a
     copy of the Corresponding Source for all the software in the
     product that is covered by this License, on a durable physical
     medium customarily used for software interchange, for a price no
     more than your reasonable cost of physically performing this
     conveying of source, or (2) access to copy the Corresponding Source
     from a network server at no charge.

  c. Convey individual copies of the object code with a copy of the
     written offer to provide the Corresponding Source.  This
     alternative is allowed only occasionally and noncommercially, and
     only if you received the object code with such an offer, in accord
     with subsection 6b.

  d. Convey the object code by offering access from a designated place
     (gratis or for a charge), and offer equivalent access to the
     Corresponding Source in the same way through the same place at no
     further charge.  You need not require recipients to copy the
     Corresponding Source along with the object code.  If the place to
     copy the object code is a network server, the Corresponding Source
     may be on a different server (operated by you or a third party)
     that supports equivalent copying facilities, provided you maintain
     clear directions next to the object code saying where to find the
     Corresponding Source.  Regardless of what server hosts the
     Corresponding Source, you remain obligated to ensure that it is
     available for as long as needed to satisfy these requirements.

  e. Convey the object code using peer-to-peer transmission, provided
     you inform other peers where the object code and Corresponding
     Source of the work are being offered to the general public at no
     charge under subsection 6d.

A separable portion of the object code, whose source code is excluded
from the Corresponding Source as a System Library, need not be included
in conveying the object code work.

A “User Product” is either (1) a “consumer product”, which means any
tangible personal property which is normally used for personal, family,
or household purposes, or (2) anything designed or sold for
incorporation into a dwelling.  In determining whether a product is a
consumer product, doubtful cases shall be resolved in favor of coverage.
For a particular product received by a particular user, “normally used”
refers to a typical or common use of that class of product, regardless
of the status of the particular user or of the way in which the
particular user actually uses, or expects or is expected to use, the
product.  A product is a consumer product regardless of whether the
product has substantial commercial, industrial or non-consumer uses,
unless such uses represent the only significant mode of use of the
product.

“Installation Information” for a User Product means any methods,
procedures, authorization keys, or other information required to install
and execute modified versions of a covered work in that User Product
from a modified version of its Corresponding Source.  The information
must suffice to ensure that the continued functioning of the modified
object code is in no case prevented or interfered with solely because
modification has been made.

If you convey an object code work under this section in, or with, or
specifically for use in, a User Product, and the conveying occurs as
part of a transaction in which the right of possession and use of the
User Product is transferred to the recipient in perpetuity or for a
fixed term (regardless of how the transaction is characterized), the
Corresponding Source conveyed under this section must be accompanied by
the Installation Information.  But this requirement does not apply if
neither you nor any third party retains the ability to install modified
object code on the User Product (for example, the work has been
installed in ROM).

The requirement to provide Installation Information does not include a
requirement to continue to provide support service, warranty, or updates
for a work that has been modified or installed by the recipient, or for
the User Product in which it has been modified or installed.  Access to
a network may be denied when the modification itself materially and
adversely affects the operation of the network or violates the rules and
protocols for communication across the network.

Corresponding Source conveyed, and Installation Information provided, in
accord with this section must be in a format that is publicly documented
(and with an implementation available to the public in source code
form), and must require no special password or key for unpacking,
reading or copying.

3.2.8 7. Additional Terms.
--------------------------

“Additional permissions” are terms that supplement the terms of this
License by making exceptions from one or more of its conditions.
Additional permissions that are applicable to the entire Program shall
be treated as though they were included in this License, to the extent
that they are valid under applicable law.  If additional permissions
apply only to part of the Program, that part may be used separately
under those permissions, but the entire Program remains governed by this
License without regard to the additional permissions.

When you convey a copy of a covered work, you may at your option remove
any additional permissions from that copy, or from any part of it.
(Additional permissions may be written to require their own removal in
certain cases when you modify the work.)  You may place additional
permissions on material, added by you to a covered work, for which you
have or can give appropriate copyright permission.

Notwithstanding any other provision of this License, for material you
add to a covered work, you may (if authorized by the copyright holders
of that material) supplement the terms of this License with terms:

  a. Disclaiming warranty or limiting liability differently from the
     terms of sections 15 and 16 of this License; or

  b. Requiring preservation of specified reasonable legal notices or
     author attributions in that material or in the Appropriate Legal
     Notices displayed by works containing it; or

  c. Prohibiting misrepresentation of the origin of that material, or
     requiring that modified versions of such material be marked in
     reasonable ways as different from the original version; or

  d. Limiting the use for publicity purposes of names of licensors or
     authors of the material; or

  e. Declining to grant rights under trademark law for use of some trade
     names, trademarks, or service marks; or

  f. Requiring indemnification of licensors and authors of that material
     by anyone who conveys the material (or modified versions of it)
     with contractual assumptions of liability to the recipient, for any
     liability that these contractual assumptions directly impose on
     those licensors and authors.

All other non-permissive additional terms are considered “further
restrictions” within the meaning of section 10.  If the Program as you
received it, or any part of it, contains a notice stating that it is
governed by this License along with a term that is a further
restriction, you may remove that term.  If a license document contains a
further restriction but permits relicensing or conveying under this
License, you may add to a covered work material governed by the terms of
that license document, provided that the further restriction does not
survive such relicensing or conveying.

If you add terms to a covered work in accord with this section, you must
place, in the relevant source files, a statement of the additional terms
that apply to those files, or a notice indicating where to find the
applicable terms.

Additional terms, permissive or non-permissive, may be stated in the
form of a separately written license, or stated as exceptions; the above
requirements apply either way.

3.2.9 8. Termination.
---------------------

You may not propagate or modify a covered work except as expressly
provided under this License.  Any attempt otherwise to propagate or
modify it is void, and will automatically terminate your rights under
this License (including any patent licenses granted under the third
paragraph of section 11).

However, if you cease all violation of this License, then your license
from a particular copyright holder is reinstated (a) provisionally,
unless and until the copyright holder explicitly and finally terminates
your license, and (b) permanently, if the copyright holder fails to
notify you of the violation by some reasonable means prior to 60 days
after the cessation.

Moreover, your license from a particular copyright holder is reinstated
permanently if the copyright holder notifies you of the violation by
some reasonable means, this is the first time you have received notice
of violation of this License (for any work) from that copyright holder,
and you cure the violation prior to 30 days after your receipt of the
notice.

Termination of your rights under this section does not terminate the
licenses of parties who have received copies or rights from you under
this License.  If your rights have been terminated and not permanently
reinstated, you do not qualify to receive new licenses for the same
material under section 10.

3.2.10 9. Acceptance Not Required for Having Copies.
----------------------------------------------------

You are not required to accept this License in order to receive or run a
copy of the Program.  Ancillary propagation of a covered work occurring
solely as a consequence of using peer-to-peer transmission to receive a
copy likewise does not require acceptance.  However, nothing other than
this License grants you permission to propagate or modify any covered
work.  These actions infringe copyright if you do not accept this
License.  Therefore, by modifying or propagating a covered work, you
indicate your acceptance of this License to do so.

3.2.11 10. Automatic Licensing of Downstream Recipients.
--------------------------------------------------------

Each time you convey a covered work, the recipient automatically
receives a license from the original licensors, to run, modify and
propagate that work, subject to this License.  You are not responsible
for enforcing compliance by third parties with this License.

An “entity transaction” is a transaction transferring control of an
organization, or substantially all assets of one, or subdividing an
organization, or merging organizations.  If propagation of a covered
work results from an entity transaction, each party to that transaction
who receives a copy of the work also receives whatever licenses to the
work the party’s predecessor in interest had or could give under the
previous paragraph, plus a right to possession of the Corresponding
Source of the work from the predecessor in interest, if the predecessor
has it or can get it with reasonable efforts.

You may not impose any further restrictions on the exercise of the
rights granted or affirmed under this License.  For example, you may not
impose a license fee, royalty, or other charge for exercise of rights
granted under this License, and you may not initiate litigation
(including a cross-claim or counterclaim in a lawsuit) alleging that any
patent claim is infringed by making, using, selling, offering for sale,
or importing the Program or any portion of it.

3.2.12 11. Patents.
-------------------

A “contributor” is a copyright holder who authorizes use under this
License of the Program or a work on which the Program is based.  The
work thus licensed is called the contributor’s “contributor version”.

A contributor’s “essential patent claims” are all patent claims owned or
controlled by the contributor, whether already acquired or hereafter
acquired, that would be infringed by some manner, permitted by this
License, of making, using, or selling its contributor version, but do
not include claims that would be infringed only as a consequence of
further modification of the contributor version.  For purposes of this
definition, “control” includes the right to grant patent sublicenses in
a manner consistent with the requirements of this License.

Each contributor grants you a non-exclusive, worldwide, royalty-free
patent license under the contributor’s essential patent claims, to make,
use, sell, offer for sale, import and otherwise run, modify and
propagate the contents of its contributor version.

In the following three paragraphs, a “patent license” is any express
agreement or commitment, however denominated, not to enforce a patent
(such as an express permission to practice a patent or covenant not to
sue for patent infringement).  To “grant” such a patent license to a
party means to make such an agreement or commitment not to enforce a
patent against the party.

If you convey a covered work, knowingly relying on a patent license, and
the Corresponding Source of the work is not available for anyone to
copy, free of charge and under the terms of this License, through a
publicly available network server or other readily accessible means,
then you must either (1) cause the Corresponding Source to be so
available, or (2) arrange to deprive yourself of the benefit of the
patent license for this particular work, or (3) arrange, in a manner
consistent with the requirements of this License, to extend the patent
license to downstream recipients.  “Knowingly relying” means you have
actual knowledge that, but for the patent license, your conveying the
covered work in a country, or your recipient’s use of the covered work
in a country, would infringe one or more identifiable patents in that
country that you have reason to believe are valid.

If, pursuant to or in connection with a single transaction or
arrangement, you convey, or propagate by procuring conveyance of, a
covered work, and grant a patent license to some of the parties
receiving the covered work authorizing them to use, propagate, modify or
convey a specific copy of the covered work, then the patent license you
grant is automatically extended to all recipients of the covered work
and works based on it.

A patent license is “discriminatory” if it does not include within the
scope of its coverage, prohibits the exercise of, or is conditioned on
the non-exercise of one or more of the rights that are specifically
granted under this License.  You may not convey a covered work if you
are a party to an arrangement with a third party that is in the business
of distributing software, under which you make payment to the third
party based on the extent of your activity of conveying the work, and
under which the third party grants, to any of the parties who would
receive the covered work from you, a discriminatory patent license (a)
in connection with copies of the covered work conveyed by you (or copies
made from those copies), or (b) primarily for and in connection with
specific products or compilations that contain the covered work, unless
you entered into that arrangement, or that patent license was granted,
prior to 28 March 2007.

Nothing in this License shall be construed as excluding or limiting any
implied license or other defenses to infringement that may otherwise be
available to you under applicable patent law.

3.2.13 12. No Surrender of Others’ Freedom.
-------------------------------------------

If conditions are imposed on you (whether by court order, agreement or
otherwise) that contradict the conditions of this License, they do not
excuse you from the conditions of this License.  If you cannot convey a
covered work so as to satisfy simultaneously your obligations under this
License and any other pertinent obligations, then as a consequence you
may not convey it at all.  For example, if you agree to terms that
obligate you to collect a royalty for further conveying from those to
whom you convey the Program, the only way you could satisfy both those
terms and this License would be to refrain entirely from conveying the
Program.

3.2.14 13. Use with the GNU Affero General Public License.
----------------------------------------------------------

Notwithstanding any other provision of this License, you have permission
to link or combine any covered work with a work licensed under version 3
of the GNU Affero General Public License into a single combined work,
and to convey the resulting work.  The terms of this License will
continue to apply to the part which is the covered work, but the special
requirements of the GNU Affero General Public License, section 13,
concerning interaction through a network will apply to the combination
as such.

3.2.15 14. Revised Versions of this License.
--------------------------------------------

The Free Software Foundation may publish revised and/or new versions of
the GNU General Public License from time to time.  Such new versions
will be similar in spirit to the present version, but may differ in
detail to address new problems or concerns.

Each version is given a distinguishing version number.  If the Program
specifies that a certain numbered version of the GNU General Public
License “or any later version” applies to it, you have the option of
following the terms and conditions either of that numbered version or of
any later version published by the Free Software Foundation.  If the
Program does not specify a version number of the GNU General Public
License, you may choose any version ever published by the Free Software
Foundation.

If the Program specifies that a proxy can decide which future versions
of the GNU General Public License can be used, that proxy’s public
statement of acceptance of a version permanently authorizes you to
choose that version for the Program.

Later license versions may give you additional or different permissions.
However, no additional obligations are imposed on any author or
copyright holder as a result of your choosing to follow a later version.

3.2.16 15. Disclaimer of Warranty.
----------------------------------

THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM “AS IS” WITHOUT
WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF
THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME
THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

3.2.17 16. Limitation of Liability.
-----------------------------------

IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR
CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT
NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES
SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE
WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN
ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

3.2.18 17. Interpretation of Sections 15 and 16.
------------------------------------------------

If the disclaimer of warranty and limitation of liability provided above
cannot be given local legal effect according to their terms, reviewing
courts shall apply local law that most closely approximates an absolute
waiver of all civil liability in connection with the Program, unless a
warranty or assumption of liability accompanies a copy of the Program in
return for a fee.

END OF TERMS AND CONDITIONS

3.3 How to Apply These Terms to Your New Programs
=================================================

If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these
terms.

To do so, attach the following notices to the program.  It is safest to
attach them to the start of each source file to most effectively state
the exclusion of warranty; and each file should have at least the
“copyright” line and a pointer to where the full notice is found.

     <one line to give the program's name and a brief idea of what it does.>
     Copyright (C) <year>  <name of author>

     This program is free software: you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation, either version 3 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program.  If not, see <https://www.gnu.org/licenses/>.

Also add information on how to contact you by electronic and paper mail.

If the program does terminal interaction, make it output a short notice
like this when it starts in an interactive mode:

     <program>  Copyright (C) <year>  <name of author>
     This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
     This is free software, and you are welcome to redistribute it
     under certain conditions; type `show c' for details.

The hypothetical commands ‘show w’ and ‘show c’ should show the
appropriate parts of the General Public License.  Of course, your
program’s commands might be different; for a GUI interface, you would
use an “about box”.

You should also get your employer (if you work as a programmer) or
school, if any, to sign a “copyright disclaimer” for the program, if
necessary.  For more information on this, and how to apply and follow
the GNU GPL, see ‘https://www.gnu.org/licenses/’.

The GNU General Public License does not permit incorporating your
program into proprietary programs.  If your program is a subroutine
library, you may consider it more useful to permit linking proprietary
applications with the library.  If this is what you want to do, use the
GNU Lesser General Public License instead of this License.  But first,
please read ‘https://www.gnu.org/licenses/why-not-lgpl.html’.

4 GNU Free Documentation License
********************************

Version 1.3, 3 November 2008

Copyright 2000, 2001, 2002, 2007, 2008 Free Software Foundation, Inc
‘https://fsf.org/’

Everyone is permitted to copy and distribute verbatim copies of this
license document, but changing it is not allowed.

4.1 Preamble
============

The purpose of this License is to make a manual, textbook, or other
functional and useful document “free” in the sense of freedom: to assure
everyone the effective freedom to copy and redistribute it, with or
without modifying it, either commercially or noncommercially.
Secondarily, this License preserves for the author and publisher a way
to get credit for their work, while not being considered responsible for
modifications made by others.

This License is a kind of “copyleft”, which means that derivative works
of the document must themselves be free in the same sense.  It
complements the GNU General Public License, which is a copyleft license
designed for free software.

We have designed this License in order to use it for manuals for free
software, because free software needs free documentation: a free program
should come with manuals providing the same freedoms that the software
does.  But this License is not limited to software manuals; it can be
used for any textual work, regardless of subject matter or whether it is
published as a printed book.  We recommend this License principally for
works whose purpose is instruction or reference.

4.2 1. APPLICABILITY AND DEFINITIONS
====================================

This License applies to any manual or other work, in any medium, that
contains a notice placed by the copyright holder saying it can be
distributed under the terms of this License.  Such a notice grants a
world-wide, royalty-free license, unlimited in duration, to use that
work under the conditions stated herein.  The ‘Document’, below, refers
to any such manual or work.  Any member of the public is a licensee, and
is addressed as “‘you’”.  You accept the license if you copy, modify or
distribute the work in a way requiring permission under copyright law.

A “‘Modified Version’” of the Document means any work containing the
Document or a portion of it, either copied verbatim, or with
modifications and/or translated into another language.

A “‘Secondary Section’” is a named appendix or a front-matter section of
the Document that deals exclusively with the relationship of the
publishers or authors of the Document to the Document’s overall subject
(or to related matters) and contains nothing that could fall directly
within that overall subject.  (Thus, if the Document is in part a
textbook of mathematics, a Secondary Section may not explain any
mathematics.)  The relationship could be a matter of historical
connection with the subject or with related matters, or of legal,
commercial, philosophical, ethical or political position regarding them.

The “‘Invariant Sections’” are certain Secondary Sections whose titles
are designated, as being those of Invariant Sections, in the notice that
says that the Document is released under this License.  If a section
does not fit the above definition of Secondary then it is not allowed to
be designated as Invariant.  The Document may contain zero Invariant
Sections.  If the Document does not identify any Invariant Sections then
there are none.

The “‘Cover Texts’” are certain short passages of text that are listed,
as Front-Cover Texts or Back-Cover Texts, in the notice that says that
the Document is released under this License.  A Front-Cover Text may be
at most 5 words, and a Back-Cover Text may be at most 25 words.

A “‘Transparent’” copy of the Document means a machine-readable copy,
represented in a format whose specification is available to the general
public, that is suitable for revising the document straightforwardly
with generic text editors or (for images composed of pixels) generic
paint programs or (for drawings) some widely available drawing editor,
and that is suitable for input to text formatters or for automatic
translation to a variety of formats suitable for input to text
formatters.  A copy made in an otherwise Transparent file format whose
markup, or absence of markup, has been arranged to thwart or discourage
subsequent modification by readers is not Transparent.  An image format
is not Transparent if used for any substantial amount of text.  A copy
that is not “Transparent” is called ‘Opaque’.

Examples of suitable formats for Transparent copies include plain ASCII
without markup, Texinfo input format, LaTeX input format, SGML or XML
using a publicly available DTD, and standard-conforming simple HTML,
PostScript or PDF designed for human modification.  Examples of
transparent image formats include PNG, XCF and JPG. Opaque formats
include proprietary formats that can be read and edited only by
proprietary word processors, SGML or XML for which the DTD and/or
processing tools are not generally available, and the machine-generated
HTML, PostScript or PDF produced by some word processors for output
purposes only.

The “‘Title Page’” means, for a printed book, the title page itself,
plus such following pages as are needed to hold, legibly, the material
this License requires to appear in the title page.  For works in formats
which do not have any title page as such, “Title Page” means the text
near the most prominent appearance of the work’s title, preceding the
beginning of the body of the text.

The “‘publisher’” means any person or entity that distributes copies of
the Document to the public.

A section “‘Entitled XYZ’” means a named subunit of the Document whose
title either is precisely XYZ or contains XYZ in parentheses following
text that translates XYZ in another language.  (Here XYZ stands for a
specific section name mentioned below, such as “‘Acknowledgements’”,
“‘Dedications’”, “‘Endorsements’”, or “‘History’”.)  To “‘Preserve the
Title’” of such a section when you modify the Document means that it
remains a section “Entitled XYZ” according to this definition.

The Document may include Warranty Disclaimers next to the notice which
states that this License applies to the Document.  These Warranty
Disclaimers are considered to be included by reference in this License,
but only as regards disclaiming warranties: any other implication that
these Warranty Disclaimers may have is void and has no effect on the
meaning of this License.

4.3 2. VERBATIM COPYING
=======================

You may copy and distribute the Document in any medium, either
commercially or noncommercially, provided that this License, the
copyright notices, and the license notice saying this License applies to
the Document are reproduced in all copies, and that you add no other
conditions whatsoever to those of this License.  You may not use
technical measures to obstruct or control the reading or further copying
of the copies you make or distribute.  However, you may accept
compensation in exchange for copies.  If you distribute a large enough
number of copies you must also follow the conditions in section 3.

You may also lend copies, under the same conditions stated above, and
you may publicly display copies.

4.4 3. COPYING IN QUANTITY
==========================

If you publish printed copies (or copies in media that commonly have
printed covers) of the Document, numbering more than 100, and the
Document’s license notice requires Cover Texts, you must enclose the
copies in covers that carry, clearly and legibly, all these Cover Texts:
Front-Cover Texts on the front cover, and Back-Cover Texts on the back
cover.  Both covers must also clearly and legibly identify you as the
publisher of these copies.  The front cover must present the full title
with all words of the title equally prominent and visible.  You may add
other material on the covers in addition.  Copying with changes limited
to the covers, as long as they preserve the title of the Document and
satisfy these conditions, can be treated as verbatim copying in other
respects.

If the required texts for either cover are too voluminous to fit
legibly, you should put the first ones listed (as many as fit
reasonably) on the actual cover, and continue the rest onto adjacent
pages.

If you publish or distribute Opaque copies of the Document numbering
more than 100, you must either include a machine-readable Transparent
copy along with each Opaque copy, or state in or with each Opaque copy a
computer-network location from which the general network-using public
has access to download using public-standard network protocols a
complete Transparent copy of the Document, free of added material.  If
you use the latter option, you must take reasonably prudent steps, when
you begin distribution of Opaque copies in quantity, to ensure that this
Transparent copy will remain thus accessible at the stated location
until at least one year after the last time you distribute an Opaque
copy (directly or through your agents or retailers) of that edition to
the public.

It is requested, but not required, that you contact the authors of the
Document well before redistributing any large number of copies, to give
them a chance to provide you with an updated version of the Document.

4.5 4. MODIFICATIONS
====================

You may copy and distribute a Modified Version of the Document under the
conditions of sections 2 and 3 above, provided that you release the
Modified Version under precisely this License, with the Modified Version
filling the role of the Document, thus licensing distribution and
modification of the Modified Version to whoever possesses a copy of it.
In addition, you must do these things in the Modified Version:

  A. Use in the Title Page (and on the covers, if any) a title distinct
     from that of the Document, and from those of previous versions
     (which should, if there were any, be listed in the History section
     of the Document).  You may use the same title as a previous version
     if the original publisher of that version gives permission.

  B. List on the Title Page, as authors, one or more persons or entities
     responsible for authorship of the modifications in the Modified
     Version, together with at least five of the principal authors of
     the Document (all of its principal authors, if it has fewer than
     five), unless they release you from this requirement.

  C. State on the Title page the name of the publisher of the Modified
     Version, as the publisher.

  D. Preserve all the copyright notices of the Document.

  E. Add an appropriate copyright notice for your modifications adjacent
     to the other copyright notices.

  F. Include, immediately after the copyright notices, a license notice
     giving the public permission to use the Modified Version under the
     terms of this License, in the form shown in the Addendum below.

  G. Preserve in that license notice the full lists of Invariant
     Sections and required Cover Texts given in the Document’s license
     notice.

  H. Include an unaltered copy of this License.

  I. Preserve the section Entitled “History”, Preserve its Title, and
     add to it an item stating at least the title, year, new authors,
     and publisher of the Modified Version as given on the Title Page.
     If there is no section Entitled “History” in the Document, create
     one stating the title, year, authors, and publisher of the Document
     as given on its Title Page, then add an item describing the
     Modified Version as stated in the previous sentence.

  J. Preserve the network location, if any, given in the Document for
     public access to a Transparent copy of the Document, and likewise
     the network locations given in the Document for previous versions
     it was based on.  These may be placed in the “History” section.
     You may omit a network location for a work that was published at
     least four years before the Document itself, or if the original
     publisher of the version it refers to gives permission.

  K. For any section Entitled “Acknowledgements” or “Dedications”,
     Preserve the Title of the section, and preserve in the section all
     the substance and tone of each of the contributor acknowledgements
     and/or dedications given therein.

  L. Preserve all the Invariant Sections of the Document, unaltered in
     their text and in their titles.  Section numbers or the equivalent
     are not considered part of the section titles.

  M. Delete any section Entitled “Endorsements”.  Such a section may not
     be included in the Modified Version.

  N. Do not retitle any existing section to be Entitled “Endorsements”
     or to conflict in title with any Invariant Section.

  O. Preserve any Warranty Disclaimers.

If the Modified Version includes new front-matter sections or appendices
that qualify as Secondary Sections and contain no material copied from
the Document, you may at your option designate some or all of these
sections as invariant.  To do this, add their titles to the list of
Invariant Sections in the Modified Version’s license notice.  These
titles must be distinct from any other section titles.

You may add a section Entitled “Endorsements”, provided it contains
nothing but endorsements of your Modified Version by various parties—for
example, statements of peer review or that the text has been approved by
an organization as the authoritative definition of a standard.

You may add a passage of up to five words as a Front-Cover Text, and a
passage of up to 25 words as a Back-Cover Text, to the end of the list
of Cover Texts in the Modified Version.  Only one passage of Front-Cover
Text and one of Back-Cover Text may be added by (or through arrangements
made by) any one entity.  If the Document already includes a cover text
for the same cover, previously added by you or by arrangement made by
the same entity you are acting on behalf of, you may not add another;
but you may replace the old one, on explicit permission from the
previous publisher that added the old one.

The author(s) and publisher(s) of the Document do not by this License
give permission to use their names for publicity for or to assert or
imply endorsement of any Modified Version.

4.6 5. COMBINING DOCUMENTS
==========================

You may combine the Document with other documents released under this
License, under the terms defined in section 4 above for modified
versions, provided that you include in the combination all of the
Invariant Sections of all of the original documents, unmodified, and
list them all as Invariant Sections of your combined work in its license
notice, and that you preserve all their Warranty Disclaimers.

The combined work need only contain one copy of this License, and
multiple identical Invariant Sections may be replaced with a single
copy.  If there are multiple Invariant Sections with the same name but
different contents, make the title of each such section unique by adding
at the end of it, in parentheses, the name of the original author or
publisher of that section if known, or else a unique number.  Make the
same adjustment to the section titles in the list of Invariant Sections
in the license notice of the combined work.

In the combination, you must combine any sections Entitled “History” in
the various original documents, forming one section Entitled “History”;
likewise combine any sections Entitled “Acknowledgements”, and any
sections Entitled “Dedications”.  You must delete all sections Entitled
“Endorsements”.

4.7 6. COLLECTIONS OF DOCUMENTS
===============================

You may make a collection consisting of the Document and other documents
released under this License, and replace the individual copies of this
License in the various documents with a single copy that is included in
the collection, provided that you follow the rules of this License for
verbatim copying of each of the documents in all other respects.

You may extract a single document from such a collection, and distribute
it individually under this License, provided you insert a copy of this
License into the extracted document, and follow this License in all
other respects regarding verbatim copying of that document.

4.8 7. AGGREGATION WITH INDEPENDENT WORKS
=========================================

A compilation of the Document or its derivatives with other separate and
independent documents or works, in or on a volume of a storage or
distribution medium, is called an “aggregate” if the copyright resulting
from the compilation is not used to limit the legal rights of the
compilation’s users beyond what the individual works permit.  When the
Document is included in an aggregate, this License does not apply to the
other works in the aggregate which are not themselves derivative works
of the Document.

If the Cover Text requirement of section 3 is applicable to these copies
of the Document, then if the Document is less than one half of the
entire aggregate, the Document’s Cover Texts may be placed on covers
that bracket the Document within the aggregate, or the electronic
equivalent of covers if the Document is in electronic form.  Otherwise
they must appear on printed covers that bracket the whole aggregate.

4.9 8. TRANSLATION
==================

Translation is considered a kind of modification, so you may distribute
translations of the Document under the terms of section 4.  Replacing
Invariant Sections with translations requires special permission from
their copyright holders, but you may include translations of some or all
Invariant Sections in addition to the original versions of these
Invariant Sections.  You may include a translation of this License, and
all the license notices in the Document, and any Warranty Disclaimers,
provided that you also include the original English version of this
License and the original versions of those notices and disclaimers.  In
case of a disagreement between the translation and the original version
of this License or a notice or disclaimer, the original version will
prevail.

If a section in the Document is Entitled “Acknowledgements”,
“Dedications”, or “History”, the requirement (section 4) to Preserve its
Title (section 1) will typically require changing the actual title.

4.10 9. TERMINATION
===================

You may not copy, modify, sublicense, or distribute the Document except
as expressly provided under this License.  Any attempt otherwise to
copy, modify, sublicense, or distribute it is void, and will
automatically terminate your rights under this License.

However, if you cease all violation of this License, then your license
from a particular copyright holder is reinstated (a) provisionally,
unless and until the copyright holder explicitly and finally terminates
your license, and (b) permanently, if the copyright holder fails to
notify you of the violation by some reasonable means prior to 60 days
after the cessation.

Moreover, your license from a particular copyright holder is reinstated
permanently if the copyright holder notifies you of the violation by
some reasonable means, this is the first time you have received notice
of violation of this License (for any work) from that copyright holder,
and you cure the violation prior to 30 days after your receipt of the
notice.

Termination of your rights under this section does not terminate the
licenses of parties who have received copies or rights from you under
this License.  If your rights have been terminated and not permanently
reinstated, receipt of a copy of some or all of the same material does
not give you any rights to use it.

4.11 10. FUTURE REVISIONS OF THIS LICENSE
=========================================

The Free Software Foundation may publish new, revised versions of the
GNU Free Documentation License from time to time.  Such new versions
will be similar in spirit to the present version, but may differ in
detail to address new problems or concerns.  See
‘https://www.gnu.org/copyleft/’.

Each version of the License is given a distinguishing version number.
If the Document specifies that a particular numbered version of this
License “or any later version” applies to it, you have the option of
following the terms and conditions either of that specified version or
of any later version that has been published (not as a draft) by the
Free Software Foundation.  If the Document does not specify a version
number of this License, you may choose any version ever published (not
as a draft) by the Free Software Foundation.  If the Document specifies
that a proxy can decide which future versions of this License can be
used, that proxy’s public statement of acceptance of a version
permanently authorizes you to choose that version for the Document.

4.12 11. RELICENSING
====================

“Massive Multiauthor Collaboration Site” (or “MMC Site”) means any World
Wide Web server that publishes copyrightable works and also provides
prominent facilities for anybody to edit those works.  A public wiki
that anybody can edit is an example of such a server.  A “Massive
Multiauthor Collaboration” (or “MMC”) contained in the site means any
set of copyrightable works thus published on the MMC site.

“CC-BY-SA” means the Creative Commons Attribution-Share Alike 3.0
license published by Creative Commons Corporation, a not-for-profit
corporation with a principal place of business in San Francisco,
California, as well as future copyleft versions of that license
published by that same organization.

“Incorporate” means to publish or republish a Document, in whole or in
part, as part of another Document.

An MMC is “eligible for relicensing” if it is licensed under this
License, and if all works that were first published under this License
somewhere other than this MMC, and subsequently incorporated in whole or
in part into the MMC, (1) had no cover texts or invariant sections, and
(2) were thus incorporated prior to November 1, 2008.

The operator of an MMC Site may republish an MMC contained in the site
under CC-BY-SA on the same site at any time before August 1, 2009,
provided the MMC is eligible for relicensing.

4.13 ADDENDUM: How to use this License for your documents
=========================================================

To use this License in a document you have written, include a copy of
the License in the document and put the following copyright and license
notices just after the title page:

     Copyright © YEAR YOUR NAME. Permission is granted to copy,
     distribute and/or modify this document under the terms of the GNU
     Free Documentation License, Version 1.3 or any later version
     published by the Free Software Foundation; with no Invariant
     Sections, no Front-Cover Texts, and no Back-Cover Texts.  A copy of
     the license is included in the section entitled “GNU Free
     Documentation License”.

If you have Invariant Sections, Front-Cover Texts and Back-Cover Texts,
replace the “with … Texts.” line with this:

     with the Invariant Sections being LIST THEIR TITLES, with the
     Front-Cover Texts being LIST, and with the Back-Cover Texts being
     LIST.

If you have Invariant Sections without Cover Texts, or some other
combination of the three, merge those two alternatives to suit the
situation.

If your document contains nontrivial examples of program code, we
recommend releasing these examples in parallel under your choice of free
software license, such as the GNU General Public License, to permit
their use in free software.